# Valheim Server Simple HealthCheck

A lightweight Valheim server mod to support simple health monitoring via HTTP.

## Features

This mod allows external uptime monitoring tools (e.g. UptimeRobot) to monitor the status of your Valheim server by creating a basic 
web server to listen for incoming HTTP requests. There are other solutions out there that are tied to external processes parsing server logs,
but they require running a node instance and/or other infrastructure. The intention here is to have something basic tied into the running process
that doesn't require other external dependancies.

The web server this mod creates will respond to `HEAD` and `GET` methods only. You can also specify a keyword to respond with
to facilitate keyword monitoring, if desired (and supported by your monitoring service).
See the Confgiuration section for more customization info.

The simplest way to set this mod up is to run it with your Valheim server, then point a reverse proxy to it from that machine.

## Installation

**BepinEx for Valheim is required for this plugin to work**

Install from your favorite mod manager, or manually by following these instructions:

1. Download and extract the build artifact for the [latest release](https://gitlab.com/ben-bartholomew/valheim-server-simple-healthcheck/-/releases)
2. Place the `bbar.Mods.SimpleHealthCheck.dll` file into `<GameDirectory>\Bepinex\plugins`
3. The first time the game starts with the plugin loaded, it will generate a config file: `<GameDirectory>\BepinEx\config\bbar.Mods.SimpleHealthCheck.cfg`
3. Open the cfg file to change configuration as needed. Any manual changes to that file will require a restart. The plugin is also compatible with the BepinEx configuration manager.

## Configuration

- HttpHost
  - Default: localhost
  - The HTTP host or address to bind to.
- HttpPort
  - Default: 5080
  - The HTTP port to use.
- ResponseKeyword
  - Default: VALHEIM_SERVER
  - A keyword to return in GET requests to service keyword based monitoring.
- SuccessCode
  - Default: 200
  - The HTTP status code to respond with to indicate server is running.

## Attributions

- [pulse](https://thenounproject.com/icon/pulse-1154124/) icon by [Abdo](https://thenounproject.com/abdulla_31/) on [The Noun Project](https://thenounproject.com/) (CC BY 3.0)
